                 $INCLUDE (Map.inc)                

				 NAME     EEPROM
				 PUBLIC   IAP_RWE
				 
EEPROM_Func      SEGMENT  CODE
                 RSEG     EEPROM_Func
					 
;IAP_Idel:        CLR      A
;                 MOV      IAP_CONTR,A
;				 MOV      IAP_CMD,A
;				 MOV      IAP_TRIG,A
;				 MOV      IAP_ADDRH,A
;                 MOV      IAP_ADDRL,A
;Reset following registers.
                 RET

IAP_RWE:         ORL      IAP_CONTR,#0x80
;Enable IAP function.
                 MOV      IAP_CMD,R7
;Send IAP command.
                 MOV      IAP_ADDRL,R5
				 MOV      IAP_ADDRH,R4
;Set target address.
                 MOV      A,R7
				 ADD      A,#0xFE
				 JC       IAP_W_E_Op
;Check the type of required IAP operation, read, write
;or erase. 
                 MOV      IAP_TRIG,#0x5A
				 MOV      IAP_TRIG,#0xA5
;Confirm requirement which was submitted before.
                 NOP
;Wait operation complete.
                 MOV      R7,IAP_DATA
;Output result is saved to R7.
;                 ACALL    IAP_Idel
                 RET
IAP_W_E_Op:      MOV      IAP_DATA,R3
;Send data is to write into the EEPROM, but it will be
;ingnored in sector erasion operation.
                 MOV      IAP_TRIG,#0x5A
				 MOV      IAP_TRIG,#0xA5
;Confirm requirement which was submitted before.
                 NOP
;Wait operation complete.
;                 ACALL    IAP_Idel
                 RET

				 END