                 $INCLUDE (Map.inc)                

				 NAME     ADC
			     PUBLIC   ADC_Init
				 PUBLIC   ADC_Start

ADC_Func         SEGMENT  CODE
                 RSEG     ADC_Func
			
ADC_Init:	     ANL      P1M0,#0xDF
                 ORL      P1M1,#0x20
;P1.5 is high impedance model.
                 ORL      P1ASF,#0x20
;P1.5 is analog input pin.
                 ORL      ADC_CONTR,#0xE5
                 ORL      CLK_DIV,#0x20
;Select P1.5 as ADC input, conversion costs 90 clock cycles.
;The ninth and the eighth bit of the result are stored in
;ADC_RES, and the rest of  eight-bit result are stored in
;ADC_RESL.
                 ORL      ADC_CONTR,#0x80
;Power on ADC.
                 RET
;This function will initialize ADC module.
ADC_Start:       ORL      ADC_CONTR,#0x08
;Start conversion.
WaitConvEnd:     MOV      A,ADC_CONTR
				 ANL      A,#0x10
				 JZ       WaitConvEnd
;Wait conversion complete.
                 MOV      R6,ADC_RES
				 MOV      R7,ADC_RESL
;10-bit conversion result saved to R7,R6.
                 ANL      ADC_CONTR,#0xEF
;Clean ADC flag.
				 RET
;Get voltage conversion result of the specific analog pin.
                 END